#Agent.py
from Tools import *
from agTools import *
#EM
from math import sqrt
import numpy as np

class Agent(SuperAgent):
    def __init__(self, number,myWorldState,
                 xPos, yPos, lX, rX, bY, tY, agType=""):
        # the environment
        self.number = number
        self.lX = lX
        self.rX = rX
        self.bY = bY
        self.tY = tY
        self.myWorldState = myWorldState
        self.agType=agType
        # the agent
        self.xPos = xPos
        self.yPos = yPos
        #EM - added variables:
        # Variable sight comes from parameters.py        
        self.agSight=random.uniform(1, common.sight)
        self.matches=[]
        self.agentsAroundMe=[]
        self.network=[]
        self.winner=None
        self.dealPrice=None
        self.acting=True
        if self.agType=="apartments": 
            if common.network==False:
                #add a counter
                self.duration=0
            self.minPrice = random.uniform(20.0,30.0)
            self.dealDetailList=[]
            self.contractID=None
            #1-owner-1-apartment case
            self.quantity = 1
        if self.agType=="students":
            self.maxPrice = random.uniform(30.0,40.0)
            self.quantity = 0
        # verbose switch            
        if common.verbose:
            print "agent", self.agType, "#", self.number, \
     	      "has been created at", self.xPos, ",", self.yPos

    # the action, also jumping
    def randomMovement(self,**k):
        if random.random()<=self.myWorldState.getGeneralMovingProb():
            #EM - verbose switch
            if common.verbose:
                print "agent %s # %d moving" % (self.agType,self.number)
            self.jump=1
            if k.has_key("jump"): self.jump=k["jump"]
            dx=randomMove(self.jump)
            self.xPos +=dx
            dy=randomMove(self.jump)
            self.yPos += dy
            #self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
            #self.yPos = (self.yPos + self.worldYSize) % self.worldYSize
            if self.xPos < self.lX : self.xPos=self.lX
            if self.xPos > self.rX : self.xPos=self.rX
            if self.yPos < self.bY : self.yPos=self.bY
            if self.yPos > self.tY : self.yPos=self.tY

            if abs(dx) > 4 and abs(dy) > 4 :

            # modify actionGroup "move" via local code execution
                actionGroup=actionDictionary.get("move","none")
                                    # in case, return "none"

                if actionGroup=="none": print "warning, actionGroup not found "+\
                                "in agent "+ str(self.number)

                else:
                   # this code show that it is possibile to generate local code
                   # run by the askEachAgentInCollectionAndExecLocalCode
                   # structure in mActions.py
                   if int(self.number/2)*2 == self.number:
                         oddEven = "print 'my number is even'"
                   else: oddEven = "print 'my number is odd'"
                   setLocalCode("print 'agent %s # %d made a big jump';"\
                                           % (self.agType,self.number) +\
                                oddEven)
              
    #EM - via modelSwarm
    def setNewCycleValues(self):
        self.matches=[]
        self.agentsAroundMe=[]
        if self.agType=="apartments":
            #update sight - apartments
            self.agSight+=common.sight*random.uniform(0,0.3)
            #clear list - already reported
            self.dealDetailList=[]
            #if not acting and no network
            if self.acting==False and common.network==False:
                self.duration+=1
                if self.duration==common.duration+1:
                    self.acting=True
                    self.winner.acting=True
                    self.duration=0            
        if self.acting==True:
            self.dealPrice=None
            self.winner=None
            if self.agType=="apartments":
                self.quantity=1
                self.contractID=None
            if self.agType=="students":
                self.quantity=0
        #network condition needed, since network becomes already greater for students by network
        if self.agType=="students" and common.network==False:
            #update sight - students
            self.agSight+=common.sight*random.uniform(0,0.3)

    #EM - general search
    def lookForAgentsAroundMe(self):
        locList=self.agentList[:]
        locList.remove(self)
        for anAgent in locList:
            dist=sqrt((anAgent.xPos-self.xPos)**2+(anAgent.yPos-self.yPos)**2)
            if dist<=self.agSight:
                self.agentsAroundMe.append(anAgent)
        if common.network:
            self.network+=self.agentsAroundMe[:]
            removeDuplicates(self.network)          
        if common.verbose:
            print self.number, ": I've taken a look around."

    #EM - search counterparts
    def searchStudents(self):
        if self.acting==True:
            self.lookForStudents()
        elif common.verbose:
            print self.number, "not searching."
    
    def searchApartments(self):
        if self.acting==True:
            self.lookForApartments()
        elif common.verbose:
            print self.number, "not searching."                        
        
    #EM - look for students around me
    def lookForStudents(self):
        if common.network:
            for anAgent in self.network:                
                if anAgent.agType=="students" and anAgent.acting==True:
                    self.matches.append(anAgent)
                    anAgent.matches.append(self)
        else:
            for anAgent in self.agentsAroundMe:
                if anAgent.agType=="students" and anAgent.acting==True:
                    self.matches.append(anAgent)
                    anAgent.matches.append(self)
        removeDuplicates(self.matches)
        if common.verbose:
            print self.number, ": search completed."
                
    #EM - look for apartments around me
    def lookForApartments(self):
        if common.network:
            for anAgent in self.network:
                if anAgent.agType=="apartments" and anAgent.acting==True:
                    self.matches.append(anAgent)
                    anAgent.matches.append(self)
        else:
            for anAgent in self.agentsAroundMe:
                if anAgent.agType=="apartments" and anAgent.acting==True:
                    self.matches.append(anAgent)
                    anAgent.matches.append(self)  
        removeDuplicates(self.matches)
        if common.verbose:
            print self.number, ": search completed."
        
    #EM - reports matches
    def reportMatches(self):        
        if self.acting==True:
            if len(self.matches)==0:         
                if common.verbose:
                    print "Agent", self.agType, "Nr.", self.number, \
                    ": I've no match!"
            else:
                matchNumberList=[]
                for aMatch in self.matches:
                    matchNumberList.append(aMatch.number)              
                if common.verbose:
                    print "Agent", self.agType, "Nr.", self.number, \
                    ": I've matches!", matchNumberList

    #EM - for students
    def selectBestApartment(self):
        if self.acting==True:
            choiceList=[]
            bidList=[]
            minBidderList=[]
            # price range filter
            for aMatch in self.matches:
                if self.maxPrice>=aMatch.minPrice:
                    choiceList.append(aMatch)
                    bidList.append(aMatch.minPrice)
            # best bid
            if len(choiceList)!=0:
                bestBid=min(bidList)
                for aChoice in choiceList:
                    if aChoice.minPrice==bestBid:
                        minBidderList.append(aChoice)
                w=random.randint(0,len(minBidderList)-1)
                self.winner=minBidderList[w]
                    
    #EM - for apartments
    def selectBestStudent(self):
        if self.acting==True:
            choiceList=[]
            bidList=[]
            maxBidderList=[]
            # price range filter
            for aMatch in self.matches:
                if self.minPrice<=aMatch.maxPrice:
                    choiceList.append(aMatch)
                    bidList.append(aMatch.maxPrice)
            # best bid
            if len(choiceList)!=0:
                bestBid=max(bidList)
                for aChoice in choiceList:
                    if aChoice.maxPrice==bestBid:
                        maxBidderList.append(aChoice)
                w=random.randint(0,len(maxBidderList)-1)
                self.winner=maxBidderList[w]  

    #EM - bargain and sign contract
    def bargainAndSignContract(self):
        if self.acting==True:
            for anAgent in self.agentList:
                if anAgent.winner==self and self.winner==anAgent:
                    self.dealPrice=bargainingPower(self, anAgent)
                    anAgent.dealPrice=self.dealPrice                    
                    self.quantity=0
                    anAgent.quantity=1
                    self.acting=False
                    anAgent.acting=False
                    #store contract details:
                    self.dealDetailList=[common.cycle, self.dealPrice, \
                    self.number, anAgent.number]
                    # contract
                    if common.verbose:
                        print self.number, ": I've a deal with", \
                        self.winner.number, "[", anAgent.number, "]", \
                        "! Deal price:", self.dealPrice 
    
    #EM - revise price
    def revisePrice(self):
        if common.network==False:
            if self.acting==True:
                self.revisePriceNoNetwork()
        elif self.agType=='students':
            self.consultWithStudentsNearMe()
            self.revisePriceFromStudentsNetwork()
        elif self.agType=='apartments':
            self.consultWithApartmentsNearMe()
            self.revisePriceFromApartmentsNetwork()
                
    #EM - revise price if no network is available
    def revisePriceNoNetwork(self):
        if self.agType=='students':
            self.maxPrice+=random.uniform(0, 0.5)
        if self.agType=='apartments':
            self.minPrice-=random.uniform(0, 0.5)
                    
    #EM - Consult students
    def consultWithStudentsNearMe(self):
        self.peerPriceList=[]                        
        for anAgent in self.network:
            if anAgent.agType=="students" and anAgent.dealPrice!=None:
                self.peerPriceList.append(anAgent.dealPrice)
    
    #EM - Consult apartments
    def consultWithApartmentsNearMe(self):
        self.peerPriceList=[]
        for anAgent in self.network:
            if anAgent.agType=="apartment" and anAgent.dealPrice!=None:
                self.peerPriceList.append(anAgent.dealPrice)
    
    #EM - Revise price considering network - students
    def revisePriceFromStudentsNetwork(self):
        if len(self.peerPriceList)!=0:
            #here we consider the mean, since we imagine a trade off between 
            #optimal price and the likelihood to get a flat. If agent would 
            #take the minimum, maxPrice will be too low and agent won't contract. 
            peerMeanPrice=np.mean(self.peerPriceList)
            if peerMeanPrice<self.maxPrice:
                if self.acting==False:
                    gain=1-(peerMeanPrice/self.maxPrice)
                    movingProb=movingPolicy(self, gain)
                    if random.uniform(0,1)<movingProb:
                        #undo the contract                            
                        self.acting=True
                        self.winner.acting=True
                        self.maxPrice=peerMeanPrice            
                        if common.verbose:
                            print self.number, "Too expensive; bye", \
                            self.winner.number, "!"
                else:
                    self.maxPrice=peerMeanPrice
                    if common.verbose:
                        print self.number, "New maxPrice: ", self.maxPrice
            elif common.verbose:
                print self.number, "Same maxPrice"
        else:
            if self.acting==True:
                self.revisePriceNoNetwork()
            if common.verbose:
                print self.number, "Nobody to compare price with!"
                
    #EM - Revise price - apartments    
    def revisePriceFromApartmentsNetwork(self):
        if len(self.peerPriceList)!=0:
            #here we consider the mean, since we imagine a trade off between 
            #optimal price and the likelihood to get a flat. If agent would 
            #take the minimum, maxPrice will be too low and agent won't contract. 
            peerMeanPrice=np.mean(self.peerPriceList)
            if peerMeanPrice>self.minPrice:
                if self.acting==False:
                    gain=(peerMeanPrice/self.minPrice)-1
                    movingProb=movingPolicy(self, gain)                        
                    #movingProb=1/(1+50*np.e**(-20*gain))
                    if random.uniform(0,1)<movingProb:
                        #undo the contract                            
                        self.acting=True
                        self.winner.acting=True
                        self.minPrice=peerMeanPrice         
                        if common.verbose:
                            print self.number, "New minPrice: ", self.minPrice
                else:
                    self.minPrice=peerMeanPrice
                    if common.verbose:
                        print self.number, "New minPrice: ", self.minPrice
            elif common.verbose:
                print self.number, "same minPrice"
        else:
            if self.acting==True:
                self.revisePriceNoNetwork()
            if common.verbose:
                print self.number, "nobody to compare price with!"

    # report
    def reportPosition(self,**d):
        #EM - verbose switch            
        if common.verbose:
            print self.agType, "agent # ", self.number, " is at X = ", \
            self.xPos, " Y = ", self.yPos

    #EM - report Cycle Values - via observerSwarm
    def declareContractStatus(self):
        if self.agType=="apartments":
            #if agents just made a contract
            if len(self.dealDetailList)!=0:
                common.contractList.append(self.dealDetailList)
                self.contractID=len(common.contractList)-1
            #if agents just resigned the contract
            if self.acting==True and self.quantity==0:
                self.closeContractList()

    #EM - This updates the contract list also in the last cycle - via observerSwarm
    def closeContractList(self):
        if self.agType=="apartments" and self.contractID!=None:
            if len(common.contractList[self.contractID])==4:
                common.contractList[self.contractID].\
                append(common.cycle-common.contractList[self.contractID][0])

#EM - auxiliary
def removeDuplicates(aList):
    if len(aList)>1:
        for anElement in aList:
            aCopy=aList[:]
            aCopy.remove(anElement)
            for i in aCopy:
                if anElement==i:
                    aList.remove(anElement)

#EM - moving policies
def movingPolicy(anAgent, gain):
    #logistic    
    if common.movingPolicy=='logistic':
        #students
        if anAgent.agType=='students':            
            prob=1/(1+50*np.e**(-35*gain))
        #apartments
        if anAgent.agType=='apartments':
            prob=1/(1+50*np.e**(-20*gain))
    #one
    elif common.movingPolicy=='one':
        if gain>0.:
            prob=1.
        else:
            prob=0.
    return prob

#EM - bargaining power
def bargainingPower(apartment, student):
    if common.bPower=='equal':
        a=(student.maxPrice - apartment.minPrice)/2
        return a
    else:
        #random
        b=random.uniform(apartment.minPrice, student.maxPrice)
        return b

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
    
    