from matplotlib import pyplot as plt
import numpy as np
import math
import commonVar as common

common.nOfContracts=len(common.contractList)

def createTimeSeries(nCycles,contractList,nOfContracts):
    pricesPerCycleList=[]
    contractsPerCycleList=[]
    for i in range(nCycles):
        a=[]
        for l in range(nOfContracts):
            if i+1==contractList[l][0]:
                a.append(contractList[l][1])
        if a==[]:
            a.append('nan')
        pricesPerCycleList.append(a)
        if len(a)==1 and a[0]=='nan':
            contractsPerCycleList.append(0)
        else:
            contractsPerCycleList.append(len(a))
    return pricesPerCycleList, contractsPerCycleList

common.timeSeries=createTimeSeries(observerSwarm.nCycles,common.contractList,\
common.nOfContracts)
common.pricesPerCycleList=common.timeSeries[0]
common.contractsPerCycleList=common.timeSeries[1]

#auxiliary
def removeNan(aList):
    aCopy=aList[:]
    for i in aCopy:
        if i==['nan']:
            aList.remove(['nan'])
    #print aList, aCopy
    return aList
                    
#Prices - generate overall statistics
def generalPriceStats(pricesPerCycleList):
    locList=pricesPerCycleList[:]
    locList=removeNan(locList)
    #print pricesPerCycleList
    #print locList
    locList2=[]
    for i in range(len(locList)):
        if len(locList[i])>1:
            for anElement in locList[i]:
                locList2.append(anElement)
        else:
            locList2.append(locList[i][0])
    if len(locList2)==0:
        meanG='not defined'
        varG='not defined'
        sdvG='not defined'
        maxG='not defined'
        minG='not defined'
    else:
        meanG=np.mean(locList2)
        varG=np.var(locList2)
        sdvG=np.std(locList2)
        maxG=np.max(locList2)
        minG=np.min(locList2)    
    return meanG, varG, sdvG, maxG, minG
    
common.generalPriceStats=generalPriceStats(common.pricesPerCycleList)

#Contracts - stats per cycle
def contractsStats(contractsPerCycleList):
    meanG=np.mean(contractsPerCycleList)
    varG=np.var(contractsPerCycleList)
    sdvG=np.std(contractsPerCycleList)
    maxG=np.max(contractsPerCycleList)
    minG=np.min(contractsPerCycleList)
    return meanG, varG, sdvG, maxG, minG
    
common.contractsStats=contractsStats(common.contractsPerCycleList)

#Contracts - average duration
def avDuration(contractList,nOfContracts):
    if nOfContracts==0:
        avDuration='not defined'
    else:
        a=0
        for i in range(nOfContracts):
            a+=contractList[i][4]
        avDuration=a/float(nOfContracts)
    return avDuration

if common.network:
    common.avDuration=avDuration(common.contractList,common.nOfContracts)

#auxiliary
#creates two series for mean + and - stDv:
def addStDv(meanList, stDvList):    
    meanPlusStDv=[]    
    meanMinusStDv=[]
    for i in range(len(meanList)):
        if meanList[i]!='nan' and stDvList[i]!='nan':
            meanPlusStDv.append(meanList[i]+stDvList[i])
            meanMinusStDv.append(meanList[i]-stDvList[i])
        else:
            meanPlusStDv.append('nan')
            meanMinusStDv.append('nan')
    return meanPlusStDv, meanMinusStDv
        
#Prices - stats per cycle
def priceStatsPerCycle(pricesPerCycleList):
    meanPerCycle=[]
    varPerCycle=[]
    stdPerCycle=[]
    maxPerCycle=[]
    minPerCycle=[]
    for i in range(len(pricesPerCycleList)):
        if pricesPerCycleList[i]!=['nan']:
            b=np.mean(pricesPerCycleList[i])
            c=np.var(pricesPerCycleList[i])
            d=np.std(pricesPerCycleList[i])
            e=max(pricesPerCycleList[i])
            f=min(pricesPerCycleList[i])
            meanPerCycle.append(b)
            varPerCycle.append(c)
            stdPerCycle.append(d)
            maxPerCycle.append(e)
            minPerCycle.append(f)
        else:
            meanPerCycle.append('nan')
            varPerCycle.append('nan')
            stdPerCycle.append('nan')
            maxPerCycle.append('nan')
            minPerCycle.append('nan')
    #series for representation:
    meanAndStDv=addStDv(meanPerCycle, stdPerCycle)
    return meanPerCycle, varPerCycle, stdPerCycle, \
    maxPerCycle, minPerCycle, meanAndStDv[0], meanAndStDv[1]

common.priceStatsPerCycle=priceStatsPerCycle(common.pricesPerCycleList)

#standardize the lenght of each list in pricesPerCycleList for plotting:
def standardizeListForPlotting(pricesPerCycleList):
    locList=pricesPerCycleList[:]
    b=[]
    for i in range(len(locList)):
        b.append(len(locList[i]))
    c=max(b)
    for i in range(len(locList)):
        if len(locList[i])!=c:
            while len(locList[i])!=c:
                locList[i].append('nan')
    return locList

common.pricesPerCycleListForPlotting=standardizeListForPlotting(common.pricesPerCycleList)

###__plotting_outcomes__###
print "_____simulation outcomes_____"
plt.figure(1)
one=plt.subplot(2,1,1)
#1st subplot for prices
plt.title('Prices')
#plt.xlabel('time (cycle)')
#adjust values in case of empty lists
try:
    a=max(int(math.floor(common.generalPriceStats[4]))-1, 0) 
except:
    a=0
try:
    b=int(math.ceil(common.generalPriceStats[3]))+1
except:
    b=0
try:
    c=max(int(math.floor(common.generalPriceStats[4]))-1,0)
except:
    c=0
try:
    d=max(int(math.floor(common.generalPriceStats[4]))-1,0)
except:
    d=0
try:
    e=int(math.ceil(common.generalPriceStats[3]))
except:
    e=0
#setting axis
plt.axis([0, observerSwarm.nCycles, a, b])
#plotting time series
a=one.plot(common.pricesPerCycleListForPlotting, 'bo',)
a[0].set_label('prices')
Mean_p, =one.plot(common.priceStatsPerCycle[0], 'c-', label="mean")
StDev_p, =one.plot(common.priceStatsPerCycle[5], 'g-', label="st.dev.")
StDev2_P, =one.plot(common.priceStatsPerCycle[6],'g-')
Max_P, =one.plot(common.priceStatsPerCycle[3], 'k-', label="max")
Min_P, =one.plot(common.priceStatsPerCycle[4], 'k-', label="min")
#re-labeling both axis (e.g.: x starts from 0, we want it to start from 1):
axisReorderingList=range(observerSwarm.nCycles+1)[1:]
plt.xticks(range(observerSwarm.nCycles),axisReorderingList)
plt.yticks(range(d, e+2, 1))
#legend adjustment
one.legend(loc='upper right', bbox_to_anchor=(1.2, 1))
##this reduces the x axis by 20%
#dimOne = one.get_position()
#one.set_position([dimOne.x0, dimOne.y0, dimOne.width * 0.8, dimOne.height])

#2nd subplot for contracts:
two=plt.subplot(2,1,2)
plt.title('Contracts')
plt.xlabel('time (cycle)')
plt.axis([0, observerSwarm.nCycles, max(common.contractsStats[4]-1, 0), common.contractsStats[3]+1])
Contracts, =two.plot(common.contractsPerCycleList, 'r-', label="contracts")
plt.xticks(range(observerSwarm.nCycles), axisReorderingList)
plt.yticks(range(max(common.contractsStats[4]-2, 0), common.contractsStats[3]+2,1))
two.legend(loc='upper right', bbox_to_anchor=(1.2, 1))
##this reduces the x axis by 20%
#dimTwo = two.get_position()
#two.set_position([dimTwo.x0, dimTwo.y0, dimTwo.width * 0.8, dimTwo.height])

#adjust spacing
plt.tight_layout()

print "\nContract List:"
common.contracts=len(common.contractList)
for i in range(common.contracts):
    print common.contractList[i]

print "\nPRICES - overall:",\
"\n Mean price:", common.generalPriceStats[0],\
"\n Variance:", common.generalPriceStats[1],\
"\n St.dev.:", common.generalPriceStats[2],\
"\n Maximum:", common.generalPriceStats[3],\
"\n Minimum:", common.generalPriceStats[4]

print "\nCONTRACTS - overall:",\
"\n Mean #:", common.contractsStats[0],\
"\n Variance:", common.contractsStats[1],\
"\n St.dev.:", common.contractsStats[2],\
"\n Maximum:", common.contractsStats[3],\
"\n Minimum:", common.contractsStats[4],\
"\n"\
"\n # of contracts:", common.contracts
if common.network:
    print " Average duration:", common.avDuration,"\n"

#show all plots
plt.show()
###__settings recall__###
print "_______settings reminder________",\
"\n",\
"\nSeed: ",    common.mySeed,\
"| Cycles: ", observerSwarm.nCycles,\
"| Max sight: ",   common.sight,\
"| Network: ",     common.network,\
"| Moving policy: ",   common.movingPolicy,\
"| Bargaining power: ",   common.bPower,\
"| Av.duration: ", common.duration if not common.network else "no"
print "________________________________\n"
